%define anolis_release 1

%undefine _package_note_flags
%ifnarch %{ocaml_native_compiler}
%global debug_package %{nil}
%endif

%define libname cppo

Name:           ocaml-cppo
Version:        1.6.9
Release: %{anolis_release}%{?dist}
Summary:        Equivalent of the C preprocessor for OCaml programs

License:        BSD
URL:            https://ocaml-community.github.io/cppo/
Source0:        https://github.com/ocaml-community/cppo/archive/v%{version}/%{libname}-%{version}.tar.gz

BuildRequires:  ocaml >= 4.02.3
BuildRequires:  ocaml-dune
BuildRequires:  ocaml-findlib
BuildRequires:  ocaml-ocamlbuild-devel

%description
Cppo is an equivalent of the C preprocessor targeted at the OCaml
language and its variants.

The main purpose of cppo is to provide a lightweight tool for simple
macro substitution (＃define) and file inclusion (＃include) for the
occasional case when this is useful in OCaml. Processing specific
sections of files by calling external programs is also possible via
＃ext directives.

The implementation of cppo relies on the standard library of OCaml and
on the standard parsing tools Ocamllex and Ocamlyacc, which contribute
to the robustness of cppo across OCaml versions.

%package ocamlbuild
Summary:        Preprocessing plugin for ocamlbuild
Requires:       %{name} = %{version}-%{release}
Requires:       ocaml-ocamlbuild

%description ocamlbuild
This package contains a plugin for ocamlbuild that enables calling cppo
at build time.  To use it, call ocamlbuild with the argument
`-plugin-tag package(cppo_ocamlbuild)`.

%package        doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n %{libname}-%{version}

%build
dune build %{?_smp_mflags} --verbose --profile release

%install
dune install --destdir=%{buildroot}

# We do not want the ml files
find %{buildroot}%{_libdir}/ocaml -name \*.ml -delete

# We install the documentation with the doc macro
rm -fr %{buildroot}%{_prefix}/doc

%generate_compatibility_deps

%check
dune runtest --profile release

%files
%license LICENSE.md
%{_bindir}/cppo
%{_libdir}/ocaml/cppo
%dir %{abidir}
%{abidir}/cppo-option.list

%files ocamlbuild
%{_libdir}/ocaml/cppo_ocamlbuild/

%files doc
%doc Changes.md README.md

%changelog
* Thu Mar 23 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> - 1.6.9-1
- Init from upstream
